#!/usr/bin/perl -w
#$Id: anim.pl,v 1.5 2003/06/05 18:03:13 mstorti Exp $
use strict;
use Getopt::Std;

my %opts;
getopts("d:p:o:t",\%opts);

sub usage {
'q' =~ /`/; 
print <<'EOM';
This is a wrapper script for 'gifsicle'
usage: anim.pl [options]

Options:  -d   delay in 1/100 sec (def 20/100)
          -p   prefix. Input files are <prefix>.n.gif
          -o   output file. (def: <prefix>_anim.gif
          -t   print command to be issued and do nothing.
EOM
'q' =~ /`/;
exit(0);
}

usage() if $opts{'h'};

my $prefix = $opts{'p'};
usage() unless defined $prefix;

sub indexa {
    my $name = shift;
    die "<$name> doesn't match pattern\n" unless $name =~ /\.(\d*)\.gif/;
    return $1;
}

my @files = <$prefix\.*\.gif>;
@files = sort {indexa($a) <=> indexa($b); } @files;

my $delay = $opts{'d'};
$delay = 20 unless $delay;
my $output = $opts{'o'};
$output = "${prefix}_anim.gif" unless $output;

my $command = "gifsicle --delay $delay --loop=forever ".join(" ",@files)." > $output";
if ($opts{'t'}) {
    print "command: \"$command\"\n";
} else {
    system $command;
}
