#!/bin/sh
set -x
## ===================================================================
# Proposito: script (con comentarios y comandos) para hacer una 
#            ANIMACION del Juego de la vida con la salida del HPF
#
# Antes, verificar que:
# chmod 666     vida.bat      ; accesible a lectura/escritura
# chmod 777     vida.bat      ; ahora es un archivo "ejecutable"
# chown guest02 vida.bat      ; ahora el propietario es "guest02"
# chgrp users   vida.bat      ; ahora el grupo       es "users"
## ===================================================================
# Id: vida.bat 2003/06/19  10:00 pmuda Exp pmuda
#
#  1 Compilar el programa fuente: 
#    a) o bien por etapas con:
#       pghpf -V -fast -Mautopar -Mmpi -c vida_hpf.hpf
#       pghpf -V -fast -Mautopar -Mmpi -o vida_hpf.exe vida_hpf.o
#
#    b) o bien en forma resumida con:
#       pghpf -V -fast -Mautopar -Mmpi -o vida_hpf.exe vida_hpf.hpf 
#
#  2 Corrida: por ejemplo, con 4 procesadores, hacer:
#    mpirun -machinefile machi.dat -nolocal -np 4 vida_hpf.exe
#
#  3 Convertir las "instantaneas" *.###.pgm en *.###.gif, 
#    donde # es un campo entero que numera las fotos, con:
## ===================================================================
for i in *.pgm
do 
  echo $i
  convert $i `basename $i .pgm`.gif
done
## ===================================================================
#  4 Crear un unico archivo de animacion con las diferencias 
#    entre las fotos (por eso suele ser chico), con:
## ===================================================================
     anim.pl -p gvida -t
     anim.pl -p gvida
## ===================================================================
#  5 LLamar ejecutable que carga la animacion:
     gifview gvida_anim.gif &
## ===================================================================
#  6 Activar la animacion parandose sobre la ventana y tipear 
#    la letra "a" para Activarla y "q" para salir (ver el help !)
## ===================================================================
