c -*- mode: fundamental -*-
c
c pgf90 -V -Mmp -o omp_d01.exe omp_d01.f
c
c -----------------------------------------------------------------
c
c 1 Directive: PARALLEL
c
c A Parallel Region is a block of code that is to be executed 
c in parallel by a number of threads. Each thread executes the 
c enclosed code separately.
c
c Note that all code within a parallel region is executed by each 
c thread unless other OpenMP directives specify otherwise. For 
c instance, a DO loop that lies within a parallel region will be 
c executed completely by each thread unless a parallel DO 
c directive is inserted before the loop. A DO or PARALLEL DO 
c directive is necessary if you want the loop to be executed 
c once, but with various iterations performed in parallel.
c
c It is illegal to branch out of a Parallel Region.
c
c $OMP PARALLEL  [clause]
c
c         code block
c
c !$OMP END PARALLEL
c
c The clause can be any legal one.
c =================================================================
        program parallel
        implicit none
        integer :: i
        i = 1
!$omp   parallel firstprivate (i)
        write (*,*)' i = ', i
!$omp   end parallel
        end program
c =================================================================
