c -*- mode: fundamental -*-
c
c pgf90 -V -Mmp -o omp_d04.exe omp_d04.f
c
c -----------------------------------------------------------------
c
c 4 Directive: SECTIONS
c
c The SECTIONS directive specifies that code in the the 
c enclosed SECTION blocks are to be divided among the threads 
c in the team. Each section is executed once.
c
c !$OMP SECTIONS  [clause[[,]clause ...]
c
c [!$OMP SECTION]
c         code block
c [!$OMP SECTION
c         code block]
c ...
c
c !$OMP END SECTIONS [NOWAIT]
c
c The clause can be one of the following:
c
c   * PRIVATE (list)
c   * FIRSTPRIVATE (list)
c   * LASTPRIVATE (list)
c   * REDUCTION ({operator | intrinsic):list)
c          See operator and intrinsic list for Parallel Regions.
c
c Example:
c
c Filename: sections.f
c
c This shows code that is executed
c in sections.
c
c -----------------------------------------------------------------
         program sections 
         implicit none
         integer omp_get_thread_num, tnumber 
!$omp    parallel
!$omp    sections private (tnumber) 
c .................................................................
!$omp    section
         tnumber = omp_get_thread_num ()
         write (*,*)
         write (*,*)' seccion 1: ejecutada por thread = ',tnumber    
c .................................................................
!$omp    section
         tnumber = omp_get_thread_num ()
         write (*,*)
         write (*,*)' seccion 2: ejecutada por thread = ',tnumber    
c .................................................................
!$omp    section
         tnumber = omp_get_thread_num ()
         write (*,*)
         write (*,*)' seccion 3: ejecutada por thread = ',tnumber    
c .................................................................
!$omp    section
         tnumber = omp_get_thread_num ()
         write (*,*)
         write (*,*)' seccion 4: ejecutada por thread = ',tnumber    
c .................................................................
!$omp    end sections 
!$omp    end parallel
         write (*,*)
         end program
c =================================================================
