c -*- mode: fundamental -*-
c
c pgf90 -V -Mmp -o omp_d07.exe omp_d07.f
c
c -----------------------------------------------------------------
c
c 7 Directive: CRITICAL
c
c The CRITICAL and END CRITICAL directives restrict access to 
c the enclosed code to only one thread at a time. A thread waits 
c at the beginning of the critical section until no other thread 
c in the team is executing a critical section with the same name.
c
c  !$OMP CRITICAL   [(name)]
c         block
c  !$OMP END CRITICAL [(name)]
c
c This shows a correct use of the CRITICAL directive
c 
c -----------------------------------------------------------------
        program critical
        implicit none
        integer, parameter :: idp = kind (1.0 d0)
        integer, parameter :: iin = kind (1)
c .................................................................
        integer (iin) :: omp_get_num_threads, np
        integer (iin) :: i, j
c -----------------------------------------------------------------
        j = 10
!$omp   parallel shared (j) private (np, i)
!$omp   master
        np = omp_get_num_threads ()
        write (*,*)
        write (*,*)' nro de procesos ; np ', np
!$omp   end master
c -----------------------------------------------------------------
c   *** The following is going to cause problems without a
c   *** CRITICAL directive
c -----------------------------------------------------------------
!$omp   critical
        call add_one (j)
!$omp   end critical
!$omp   end parallel
        write (*,*)
        write (*,*)' valor final de j = ', j
        contains
          subroutine add_one (i)
          implicit none
          integer (iin), intent (inout) :: i
          integer (iin) :: j
          j = i
!$omp     master
          open (1, file = 'salida.tmp', status = 'unknown')
          do i = 1, 10
          write (1,*)' Hi Mom ! '
          end do ! i
          close (1)
!$omp     end master
          j = j + 1
          i = j
          end subroutine add_one
        end program
c =================================================================


