c -*- mode: fundamental -*-
c
c pgf90 -V -Mmp -o omp_d08.exe omp_d08.f
c
c -----------------------------------------------------------------
c
c 8 Directive: BARRIER
c
c  !$OMP BARRIER
c
c The BARRIER directive synchronizes all threads in a team. 
c When encountered, each thread waits until all of the others 
c threads in that team have reached this point.
c
c Example
c
c !Filename: barrier.f
c !
c !This shows use of the BARRIER directive.
c !
c -----------------------------------------------------------------
        program barrier
        implicit none
        integer, parameter :: idp = kind (1.0 d0)
        integer, parameter :: iin = kind (1)
c .................................................................
        real    (idp), parameter ::   cero = 0.0 d0
        real    (idp), parameter ::    uno = 1.0 d0
        integer (iin), parameter :: n = 1 000
        real    (idp), parameter :: m = 1 000
c .................................................................
        integer       :: omp_get_num_threads, np
        integer       :: omp_get_thread_num , tn
        integer (iin) :: k
c .................................................................
!$omp   parallel shared (k) private (nt, tn)
        np = omp_get_num_threads ()
        tn = omp_get_thread_num  ()
!$omp   master
        write (*,*,advance = 'no')' k : ? '
        read  (*,*)  k
!$omp   end master
!$omp   barrier
!$omp   critical
        write (*,*)
        write (*,*)' My thread number  = ', tn
        write (*,*)' Number of threads = ', np
        write (*,*)' Value of k        = ', k
        write (*,*)
!$omp   end critical
!$omp   end parallel
        end program
c =================================================================
