c -*- mode: fundamental -*-
c
c pgf90 -V -Mmp -o omp_d09.exe omp_d09.f
c
c -----------------------------------------------------------------
c
c 9 Directive: FLUSH
c
c  !$OMP FLUSH (list)
c
c The FLUSH directive identifies synchronization points at 
c which the implementation is required to provide a consistent 
c view of memory. The directive must appear at the precise 
c point in the code at which the synchronization is required. 
c The optional list argument consists of a comma-separated 
c list of variables that need to be flushed in order to avoid
c flushing all variables.
c
c The FLUSH directive is implied for the following directives:
c
c   * BARRIER
c   * CRITICAL and END CRITICAL
c   * END DO
c   * END PARALLEL
c   * END SECTIONS
c   * END SINGLE
c   * ORDERED and END ORDERED
c
c The directive is not implied if NOWAIT is present.
c -----------------------------------------------------------------
