// =================================================================
// pgCC -V -Minfo -mp -fast -c omp_critico.cc
// pgCC -V -Minfo -mp -fast -o omp_critico_cc.exe omp_critico.o
// omp_critico_cc.exe
//
// -----------------------------------------------------------------
//
// 7 Directive: CRITICAL
//
// The CRITICAL and END CRITICAL directives restrict access to 
// the enclosed code to only one thread at a time. A thread waits 
// at the beginning of the critical section until no other thread 
// in the team is executing a critical section with the same name.
//
//  !$OMP CRITICAL   [(name)]
//         block
//  !$OMP END CRITICAL [(name)]
// 
// -----------------------------------------------------------------
#include <omp.h>
//#include <iostream>
main () {
  int x;
  x = 0;
  //  cout << endl ;
#pragma omp parallel shared (x) 
  {
    # pragma omp critical 
    { 
       x = x + 1;
    } // end pragma
  } // end pragma
  //  cout <<" x = " << x << endl ;
} // end main
