c =================================================================
c pgf90 -V -Minfo -mp -fast -c omp_critico.f
c pgf90 -V -Minfo -mp -fast -o omp_critico_ff.exe omp_critico.o
c omp_critico_ff.exe
c
c -----------------------------------------------------------------
c
c 7 Directive: CRITICAL
c
c The CRITICAL and END CRITICAL directives restrict access to 
c the enclosed code to only one thread at a time. A thread waits 
c at the beginning of the critical section until no other thread 
c in the team is executing a critical section with the same name.
c
c  !$OMP CRITICAL   [(name)]
c         block
c  !$OMP END CRITICAL [(name)]
c 
c -----------------------------------------------------------------
      program critico
      implicit none
      integer x
      x = 0
!$omp parallel shared (x)
!$omp critical 
      x = x + 1
!$omp end critical 
!$omp end parallel
      write (*,*)'x = ', x
      end program
c =================================================================
