// -----------------------------------------------------------------
// pgCC -V -Minfo -mp -fast -c omp_reduction.cc
// pgCC -V -Minfo -mp -fast -o omp_reduction_cc.exe omp_reduction.o
// omp_reduction_cc.exe
//
// -----------------------------------------------------------------
// OpenMP Example - Combined Parallel Loop Reduction - C/C++ Version
// FILE: omp_reduction.c
//
// DESCRIPTION:
//   This example demonstrates a sum reduction within a combined 
//   parallel loop construct.  Notice that default data element 
//   scoping is assumed - there are no clauses specifying shared 
//   or private variables.  OpenMP will automatically make loop 
//   index variables private within team threads, and global 
//    variables shared.
// SOURCE: adapted from Blaise Barney  5/99
// -----------------------------------------------------------------
#include <omp.h>
#include <iostream>
#define n 10
main () {
  int   i ;
  float a [n], b [n], suma; 
  // Some initializations
  for (i = 0 ; i < n ; i++)  a [i] = b [i] = i * 1.0 ;
  suma = 0.0;
#pragma omp parallel for reduction (+:suma)
  for (i = 0 ; i < n ; i++)
    suma = suma + a [i] * b [i];
  cout << "suma = " << suma << endl ;
} // end main
// -----------------------------------------------------------------
