c =================================================================
c pgf90 -V -Minfo -mp -fast -c omp_reduction.f
c pgf90 -V -Minfo -mp -fast -o omp_reduction_ff.exe omp_reduction.o
c omp_reduction_ff.exe
c
c -----------------------------------------------------------------
c OpenMP Example - Combined Parallel Loop Reduction 
c                  Fortran Version
c
c FILE: omp_reduction.f
c
c DESCRIPTION:
c   This example demonstrates a sum reduction within a combined 
c   parallel loop construct.  Notice that default data element 
c   scoping is assumed - there are no clauses specifying shared or 
c   private variables.  OpenMP will automatically make loop index 
c   variables private within team threads, and global variables 
c   shared.
c
c SOURCE: adapted from Blaise Barney  5/99
c -----------------------------------------------------------------
      program reduction
      implicit none
      integer, parameter :: n = 10
      real, dimension (n) :: a, b
      real :: suma
      integer :: i
c     Some initializations
      do  i = 1, n
        a (i) = i * 1.0
        b (i) = a (i)
      end do
      suma = 0.0
c$omp parallel do reduction (+:suma)
      do i = 1, n
        suma = suma + a (i) * b (i)
      end do ! i
      write (*,*)
      write (*,*)'suma = ', suma
      end program
c =================================================================
