// -----------------------------------------------------------------
// pgCC -V -Minfo -mp -fast -c omp_workshare1.cc
// pgCC -V -Minfo -mp -fast -o omp_workshare1_cc.exe omp_workshare1.o
// omp_workshare1_cc.exe
//
// -----------------------------------------------------------------
// OpenMP Example - Loop Work-sharing - C/C++ Version
//
// FILE: omp_workshare1.c
//
// DESCRIPTION:
//   In this example, the iterations of a loop are scheduled 
//   dynamically across the team of threads.  A thread will 
//   perform CHUNK = p iterations at a time before being scheduled 
//   for the next CHUNK of work.
//
// SOURCE: adapted from Blaise Barney  5/99
// -----------------------------------------------------------------
#include <omp.h>
#include <stdio.h>
main () {
  const int n = 20;
  int    nhilos, ih, i ;
  float  a [n], b [n], c [n];
  // inicializacion
  for (i = 0 ; i < n ; i++) a [i] = b [i] = i * 1.0;
# pragma omp parallel shared (a, b, c, n) private (i, ih, nhilos)
  {
    ih = omp_get_thread_num ();
    # pragma omp for schedule (dynamic,10) // chunk ; p = 10
    for (i = 0; i < n ; i++) {
      c [i] = a [i] + b [i];
      printf ("id = %d i = % d  c [i]= % f \n ", ih, i, c [i]);
    } // end for
    if (ih == 0) {
      nhilos = omp_get_num_threads ();
      printf ("numero de hilos = % d \n", nhilos);
    } // end if
  }  // end of parallel section
} // end main
// -----------------------------------------------------------------
