c =================================================================
c pgf90 -V -Minfo -mp -fast -c omp_workshare1.f
c pgf90 -V -Minfo -mp -fast -o omp_workshare1_ff.exe omp_workshare1.o
c omp_workshare1_ff.exe
c
c -----------------------------------------------------------------
c OpenMP Example - Loop Work-sharing - Fortran Version
c FILE: omp_workshare1.f
c DESCRIPTION:
c   In this example, the iterations of a loop are scheduled 
c   dynamically across the team of threads.  A thread will perform 
c   CHUNK = p iterations at a time before being scheduled for the 
c   next CHUNK of work.
c
c SOURCE: adapted form Blaise Barney  5/99
c -----------------------------------------------------------------
      program workshare1
      implicit none
      integer, parameter :: n = 100
      integer, parameter :: p =  10
      integer nhilos, ih, pedazo, i
      integer omp_get_num_threads, omp_get_thread_num
      real, dimension (n) :: a, b, c
c     inicializacion
      do i = 1, n
        a (i) = i * 1.0
        b (i) = a (i)
      end do
c$omp parallel shared (a,b,c,n) private (i, nhilos, ih)
      ih = omp_get_thread_num ()
c$omp do schedule (dynamic, p)
      do  i = 1, n
        c (i) = A (I) + B (I)
        write (*,*)'ih = ', ih ,' i = ', i,' c (i) = ', c (i)
      end do
c$omp end do nowait
      if ( ih .eq. 0 ) then
        nhilos = omp_get_num_threads ()
        write (*,*)'numero de hilos (threads) = ', nhilos
      end if
!$omp end parallel
      end program
c =================================================================
