// -----------------------------------------------------------------
// pgCC -V -Minfo -mp -fast -c omp_workshare2.cc
// pgCC -V -Minfo -mp -fast -o omp_workshare2_cc.exe omp_workshare2.o
// omp_workshare2_cc.exe
//
// -----------------------------------------------------------------
// OpenMP Example - Sections Work-sharing - C/C++ Version
// FILE: omp_workshare2.c
// DESCRIPTION:
//   In this example, the iterations of a loop are split into two 
//   different sections.  Each section will be executed by one 
//   thread. Extra threads will not participate in the sections code.
// SOURCE: adapted form Blaise Barney  5/99
// -----------------------------------------------------------------
#include <omp.h>
#include <stdio.h>
main () {  
  const int n = 20;
  float a [n], b [n], c [n];
  int i, m;
  int nhilos, ih ;  
  // inicializacion
  for (i = 0 ; i < n ; i++) a [i] = b [i] = i * 1.0;
  /* Some initializations */
  m = n / 2 ;
#pragma omp parallel shared (a,b,c,n) private (i,ih,nhilos)
  {
    ih = omp_get_thread_num ();
    printf ("inicia hilo %d ... \n ", ih);
    #pragma omp sections nowait
    {
      #pragma omp section
        for (i = 0 ; i < m ; i++) {
          c [i] = a [i] + b [i];
          printf ("ih = %d i = %d c [i]= %f \n ",ih, i, c [i]);
        } // end for
      #pragma omp section
        for (i = m ; i < n ; i++) {
          c [i] = a [i] + b [i];
          printf ("ih = %d i = %d c [i]= %f \n ", ih, i, c [i]);
        } // end for
    }  // end sections
    if (ih == 0) {
      nhilos = omp_get_num_threads ();
      printf ("numero de hilos = % d \n", nhilos);
    } // end if
  }  // end of parallel section
} // end main
// -----------------------------------------------------------------
