c =================================================================
c pgf90 -V -Minfo -mp -fast -c omp_workshare2.f
c pgf90 -V -Minfo -mp -fast -o omp_workshare2_ff.exe omp_workshare2.o
c omp_workshare2_ff.exe
c -----------------------------------------------------------------
c OpenMP Example - Sections Work-sharing - Fortran Version
c
c FILE: omp_workshare2.f
c
c DESCRIPTION:
c   In this example, the iterations of a loop are split into two 
c   different sections.  Each section will be executed by one 
c   thread.  Extra threads will not participate in the sections code.
c
c SOURCE: adapted from Blaise Barney  5/99
c -----------------------------------------------------------------
      program workshare2
      implicit none
      integer, parameter :: n = 100
      integer nhilos, ih, i, m
      integer omp_get_num_threads, omp_get_thread_num
      real, dimension (n) :: a, b, c
c     Inicializacion
      write (*,*)
      do i = 1, n
        a (i) = i * 1.0
        b (i) = a (i)
      end do ! i
      m = n / 2
c$omp parallel shared (a,b,c,m,n), private (i, nhilos, ih)
      ih = omp_get_thread_num ()
      write (*,*)'ih = ', ih
c$omp sections
c$omp section
      do i = 1, m
        c (i) = a (i) + b (i)
        write (*,*)'ih i c_i = ', ih, i, c (i)
      end do
c$omp section
      do i = 1+m, n
        c (i) = a (i) + b (i)
        write (*,*)'ih i c_i = ', ih, i, c (i)
      end do
c$omp end sections nowait
      if ( ih .eq. 0) then
        nhilos = omp_get_num_threads ()
        write (*,*)'numero de hilos (threads) = ', nhilos
      end if
c$omp end parallel
      end program
c =================================================================
