// -----------------------------------------------------------------
// pgCC -V -Minfo -mp -fast -c omp_workshare4.cc
// pgCC -V -Minfo -mp -fast -o omp_workshare4_cc.exe omp_workshare4.o
// omp_workshare4_cc.exe
//
// -----------------------------------------------------------------
// OpenMP Example - Sections Work-sharing - C/C++ Version
// FILE: omp_workshare4.c
// DESCRIPTION:
//   In this example, the iterations of a loop are split into two 
//   different sections.  Each section will be executed by one 
//   thread. Extra threads will not participate in the sections code.
// SOURCE: adapted form Blaise Barney  5/99
// -----------------------------------------------------------------
// OpenMP Example - Combined Parallel Loop Work-sharing - C/C++ Version
//
// FILE: omp_workshare4.c
//
// DESCRIPTION:
//   This is a corrected version of the omp_workshare3.c example. 
//   Corrections include removing all statements between the 
//   parallel for construct and the actual for loop, and introducing 
//   logic to preserve the ability to query a thread's id and print 
//   it from inside the for loop.
//
// SOURCE: adapted form Blaise Barney  5/99
// -----------------------------------------------------------------
#include <omp.h>
#include <stdio.h>
main ()  {
  const int n = 20;
  int i, n, ih ;
  float a [n], b [n], c [n];
  char primera_vez ;  
  // inicializacion
  for (i = 0 ; i < n ; i++) a [i] = b [i] = i * 1.0;
  primea_vez = 's';
#pragma omp parallel for      \
  shared (a,b,c,n)            \
  private (i, ih)             \
  schedule (static,5)         \
  firstprivate (primera_vez)
  for (i = 0 ; i < n ; i++) {
    if (primera_vez == 'y') {
      ih = omp_get_thread_num ();
      primera_vez = 'n';
    } // end if
    c [i] = a [i] + b [i];
    printf ("ih = %d i = % d c [i] = % f \n", ih, i, c[i]);
  } // end for
} // end main
// -----------------------------------------------------------------
