c =================================================================
c pgf90 -V -Minfo -mp -fast -c omp_workshare4.f
c pgf90 -V -Minfo -mp -fast -o omp_workshare4_ff.exe omp_workshare4.o
c omp_workshare4_ff.exe
c -----------------------------------------------------------------
c OpenMP Example - Combined Parallel Loop Work-sharing - 
c                  Fortran Version
c
c FILE: omp_workshare4.f
c
c DESCRIPTION:
c   This is a corrected version of the omp_workshare3.f example. 
c   Corrections include removing all statements between the 
c   PARALLEL DO construct and the actual DO loop, and introducing 
c   logic to preserve the ability to query a thread's ih and print 
c   it from inside the DO loop. 
c SOURCE: adapted form Blaise Barney  5/99
c -----------------------------------------------------------------
      program workshare4
      implicit none
      integer, parameter :: n =  50
      integer, parameter :: p =   5
      integer ih, i, p
      integer omp_get_thread_num
      real, dimension (n) :: a, b, c
      character (2) :: primera_vez
c     Inicializacion
      write (*,*)
      do i = 1, n
        a (i) = i * 1.0
        b (i) = a (i)
      end do ! i
      primera_vez = 'si'
c$omp  parallel do shared (a,b,c,n) 
c$omp& private (i, ih) 
c$omp& schedule (static, p)
c$omp& firstprivate (primera_vez)
      do i = 1, n
        if (primera_vez .eq. 'si') then
          ih = omp_get_thread_num ()
          primera_vez = 'no'
        end if
        c (i) = a (i) + b (i)
        write (*,*)' ih i c_i = ', ih, i, c (i)
      end do ! i
c$omp end parallel do
      end program
c =================================================================
