// -----------------------------------------------------------------
//  PGI:
//  pgCC -V -Minfo -mp -fast -c omp_a04.cpp
//  pgCC -V -Minfo -mp -fast -o omp_a04_cpp.exe omp_a04.o
//  omp_a04_cpp.exe
//
// -----------------------------------------------------------------
//  INTEL: 
//  source /opt/intel_cc_80/bin/iccvars.sh
//  alias icc='/opt/intel_cc_80/bin/icc'
//  /opt/intel_cc_80/bin/icc -openmp -c omp_a04.cpp
//  /opt/intel_cc_80/bin/icc -openmp -o omp_a04_cpp.exe omp_a04.o
//  omp_a04_cpp.exe
//
// -----------------------------------------------------------------
#include <iostream>
#include <omp.h>
#include <math.h>
using namespace std ;

// -----------------------------------------------------------------
main () {
  const int n = 100 ;
  float a [n], b [n], c [n] ;
  // titulos
  cout << endl ;
  cout << " A04: using the nowait clause" << endl ;
  cout << endl ;
  // inicializa
  #pragma omp parallel for
  for (int i = 0 ; i < n ; i++) {
    a [i] = (i + 1) * 1.0 ;
  } // end for
  // tarea demo
  #pragma omp parallel
  {
    #pragma omp for nowait
      for (int i = 0 ; i < n ; i++) 
        b [i] = ( a [i] + a [i-1] ) / 2.0 ;
    #pragma omp for nowait
      for (int i = 0 ; i < n ; i++)
        c [i] = sqrt ( b [i] ) ;
  } // end pragma
  // finaliza
  cout << endl ;
  cout << " finished "<< endl ;
  cout << endl ;
} // end main
// -----------------------------------------------------------------
