// -----------------------------------------------------------------
//  PGI:
//  pgCC -V -Minfo -mp -fast -c omp_a07.cpp
//  pgCC -V -Minfo -mp -fast -o omp_a07_cpp.exe omp_a07.o
//  omp_a07_cpp.exe
//
// -----------------------------------------------------------------
//  INTEL: 
//  source /opt/intel_cc_80/bin/iccvars.sh
//  alias icc='/opt/intel_cc_80/bin/icc'
//  /opt/intel_cc_80/bin/icc -openmp -c omp_a07.cpp
//  /opt/intel_cc_80/bin/icc -openmp -o omp_a07_cpp.exe omp_a07.o
//  omp_a07_cpp.exe
//
// -----------------------------------------------------------------
#include <iostream>
#include <omp.h>
using namespace std ;

// -----------------------------------------------------------------
main () {
  const int n = 100 ;
  float x [n], y [n] ;
  float a    , b     ;
  int   i ;
  // titulos
  cout << endl ;
  cout << " A07: using the reduction clause " << endl ;
  cout << endl ;
  // inicializa
  #pragma omp parallel for
  for (i = 0 ; i < n ; i++) {
    x [i] = (i + 1) * 1.0 ;
    y [i] = (i + 1) * 2.0 ;
  } // end for
  // tarea demo
  #pragma omp parallel for private (i) shared (x,y,n) \
                           reduction (+:a,b)
    for (i = 0 ; i < n ; i++) {
      a = a + x [i] ;
      b = b + y [i] ;
    } // end for
  cout << " a = " << a << endl ;
  cout << " b = " << b << endl ;
  // finaliza
  cout << endl ;
  cout << " finished "<< endl ;
  cout << endl ;
} // end main
// -----------------------------------------------------------------
