!  =================================================================
!   PGI:
!   pgf90 -V -Minfo -mp -fast -c omp_a07.f90
!   pgf90 -V -Minfo -mp -fast -o omp_a07_f90.exe omp_a07.o
!   omp_a07_f90.exe
! 
!  -----------------------------------------------------------------
!   INTEL: 
!   source /opt/intel_cc_80/bin/iccvars.sh
!   alias f95='/opt/intel_fc_80/bin/ifort'
!   /opt/intel_fc_80/bin/ifort -openmp -c omp_a07.f90
!   /opt/intel_fc_80/bin/ifort -openmp -o omp_a07_f90.exe omp_a07.o
!   omp_a07_f90.exe
! 
!  -----------------------------------------------------------------
!   ADAPTOR:
!   adaptor -openmp -free -o omp_a07_ada.exe omp_a07.f90
!   export OMP_NUM_THREADS=2 ; echo $OMP_NUM_THREADS
!   omp_a07_ada.exe
!
!  -----------------------------------------------------------------
program a07
  implicit none
  integer, parameter :: n = 100
  real   , dimension (n) :: x, y
  real    :: a, b
  integer :: i
  ! titulos
  write (*,*)
  write (*,*)'A07: using the reduction clause '
  write (*,*)
  ! inicializa
  !omp$ do parallel
  do  i = 1, n
    x (i) = i * 1.0
    y (i) = i * 2.0
  end do ! i
  ! tarea demo
  !omp$ parallel
    !omp$ parallel do private (i) shared (x,y,n) \
    !omp$ reduction (+:a,b)
     do   i = 1, n
       a = a + x (i)
       b = b + y (i)
     end do ! i
  !omp$ end parallel
  write (*,*)'a = ', a
  write (*,*)'b = ', b
  ! finaliza
  write (*,*)
  write (*,*)'finished '
  write (*,*)
end program
!  =================================================================
