!  =================================================================
!   PGI:
!   pgf90 -V -Minfo -mp -fast -c omp_a10.f90
!   pgf90 -V -Minfo -mp -fast -o omp_a10_f90.exe omp_a10.o
!   omp_a10_f90.exe
! 
!  -----------------------------------------------------------------
!   INTEL: 
!   source /opt/intel_cc_80/bin/iccvars.sh
!   alias f95='/opt/intel_fc_80/bin/ifort'
!   /opt/intel_fc_80/bin/ifort -openmp -c omp_a10.f90
!   /opt/intel_fc_80/bin/ifort -openmp -o omp_a10_f90.exe omp_a10.o
!   omp_a10_f90.exe
! 
!  -----------------------------------------------------------------
!   ADAPTOR:
!   adaptor -openmp -free -o omp_a10_ada.exe omp_a10.f90
!   export OMP_NUM_THREADS=2 ; echo $OMP_NUM_THREADS
!   omp_a10_ada.exe
!
!  -----------------------------------------------------------------
program a10
  implicit none
  integer, parameter :: n = 10
  integer :: i
  ! titulos
  write (*,*)
  write (*,*)'A10: using sequential ordering'
  write (*,*)
  ! tarea demo
  !omp$ do ordered schedule (dynamic)
  do  i = 1, n
    call work (i)
  end do ! i
  !omp$ end parallel
  ! finaliza
  write (*,*)
  write (*,*)'finished '
  write (*,*)
  contains
    subroutine work (i) 
      integer, intent (in) :: i
      !omp$ ordered
      write (*,*)'i = ', i
    end subroutine
end program
!  =================================================================
