// -----------------------------------------------------------------
//  PGI:
//  pgCC -V -Minfo -mp -fast -c omp_a11.cpp
//  pgCC -V -Minfo -mp -fast -o omp_a11_cpp.exe omp_a11.o
//  omp_a11_cpp.exe
//
// -----------------------------------------------------------------
//  INTEL: 
//  source /opt/intel_cc_80/bin/iccvars.sh
//  alias icc='/opt/intel_cc_80/bin/icc'
//  /opt/intel_cc_80/bin/icc -openmp -c omp_a11.cpp
//  /opt/intel_cc_80/bin/icc -openmp -o omp_a11_cpp.exe omp_a11.o
//  omp_a11_cpp.exe
//
// -----------------------------------------------------------------
#include <iostream>
#include <omp.h>
using namespace std ;

// -----------------------------------------------------------------
void work (double x,int h, int m) { cout << " h = " << h << endl ; }

// -----------------------------------------------------------------
main () {
  int   h, m, n = 100, p ;
  float x = 1.0 ;
  // titulos
  cout << endl ;
  cout << " A11: specifying a fixed number of threads " << endl ;
  cout << endl ;
  // tarea demo
  omp_set_dynamic (0);
  omp_set_num_threads (3);
  p = omp_get_num_threads ();
  cout << " p = " << p << endl ;
  cout << endl ;
  #pragma omp parallel shared (p, x, n) private (h,m)
  {
    if ( omp_get_num_threads () == 3 ) {
      h = omp_get_thread_num () ;
      m = n / 3 ;
      work (x,h,m); 
    } // end if
  } // end pragma
  // finaliza
  cout << endl ;
  cout << " finished "<< endl ;
  cout << endl ;
} // end main
// -----------------------------------------------------------------
