!  =================================================================
!   PGI:
!   pgf90 -V -Minfo -mp -fast -c omp_a11.f90
!   pgf90 -V -Minfo -mp -fast -o omp_a11_f90.exe omp_a11.o
!   omp_a11_f90.exe
! 
!  -----------------------------------------------------------------
!   INTEL: 
!   source /opt/intel_cc_80/bin/iccvars.sh
!   alias f95='/opt/intel_fc_80/bin/ifort'
!   /opt/intel_fc_80/bin/ifort -openmp -c omp_a11.f90
!   /opt/intel_fc_80/bin/ifort -openmp -o omp_a11_f90.exe omp_a11.o
!   omp_a11_f90.exe
! 
!  -----------------------------------------------------------------
!   ADAPTOR:
!   adaptor -openmp -free -o omp_a11_ada.exe omp_a11.f90
!   export OMP_NUM_THREADS=2 ; echo $OMP_NUM_THREADS
!   omp_a11_ada.exe
!
!  -----------------------------------------------------------------
program a11
  implicit none
  integer :: omp_get_num_threads
  integer :: omp_get_thread_num
  integer :: h, m, n = 100, p
  real    :: x = 1.0
  ! titulos
  write (*,*)
  write (*,*)'A11: specifying a fixed number of threads '
  write (*,*)
  ! tarea demo
  call  omp_set_dynamic (.false.)
  call  omp_set_num_threads (3)
  !omp$ parallel shared (x, n) private (h,m)
  p = omp_get_num_threads () 
  write (*,*) 'omp_get_num_threads () = ', p
  if ( omp_get_num_threads () == 3 ) then
    h = omp_get_thread_num ()
    m = n / 3
    call work (x,h,m)
  end if
  !omp$ end parallel
  ! finaliza
  write (*,*)
  write (*,*)'finished '
  write (*,*)
  contains
    subroutine work (x,h,m)
      real   , intent (in) :: x
      integer, intent (in) :: h
      integer, intent (in) :: m
      write (*,*)'h = ', h
    end subroutine
end program
!  =================================================================
