// -----------------------------------------------------------------
//  PGI:
//  pgCC -V -Minfo -mp -fast -c omp_a12.cpp
//  pgCC -V -Minfo -mp -fast -o omp_a12_cpp.exe omp_a12.o
//  omp_a12_cpp.exe
//
// -----------------------------------------------------------------
//  INTEL: 
//  source /opt/intel_cc_80/bin/iccvars.sh
//  alias icc='/opt/intel_cc_80/bin/icc'
//  /opt/intel_cc_80/bin/icc -openmp -c omp_a12.cpp
//  /opt/intel_cc_80/bin/icc -openmp -o omp_a12_cpp.exe omp_a12.o
//  omp_a12_cpp.exe
//
// -----------------------------------------------------------------
#include <iostream>
#include <omp.h>
using namespace std ;

// -----------------------------------------------------------------
int work1 (int i) { return (i+1) ; } 
int work2 (int i) { return (i+2) ; }

// -----------------------------------------------------------------
main () {
  const int n = 10 ;
  int   p [n], x [n], y [n] ;
  int   i, k ;
  // titulos
  cout << endl ;
  cout << " A12: using the atomic directive " << endl ;
  cout << endl ;
  #pragma omp parallel for
  for (i = 0 ; i < n ; i++) {
    x [i] = i + 0 ;
    y [i] = i + 1 ;
    p [i] = n - i ;
  } // end for
  // tarea demo
  #pragma omp parallel for shared (x,y,p,n) private (k)
    for (i = 1 ; i < n ; i++) {
      k = p [i];
      #pragma omp atomic
      x [k] += work1 (i) ; 
      y [i] += work2 (i) ;
    } // for
  // finaliza
  cout << endl ;
  cout << " finished "<< endl ;
  cout << endl ;
} // end main
// -----------------------------------------------------------------
