// -----------------------------------------------------------------
//  PGI:
//  pgCC -V -Minfo -mp -fast -c omp_a13.cpp
//  pgCC -V -Minfo -mp -fast -o omp_a13_cpp.exe omp_a13.o
//  omp_a13_cpp.exe
//
// -----------------------------------------------------------------
//  INTEL: 
//  source /opt/intel_cc_80/bin/iccvars.sh
//  alias icc='/opt/intel_cc_80/bin/icc'
//  /opt/intel_cc_80/bin/icc -openmp -c omp_a13.cpp
//  /opt/intel_cc_80/bin/icc -openmp -o omp_a13_cpp.exe omp_a13.o
//  omp_a13_cpp.exe
//
// -----------------------------------------------------------------
#include <iostream>
#include <omp.h>
using namespace std ;

// -----------------------------------------------------------------
int laburo (int i) { return (i+1) ; } 

// -----------------------------------------------------------------
main () {
  const int n = 3 ;
  int  w [n], s [n] ;
  int  i, v ;
  // titulos
  cout << endl ;
  cout << " A13: using the flush directive without a list " << endl ;
  // tarea demo  
  #pragma omp parallel private (i,v) shared (w,s)
  { 
    i = omp_get_thread_num () ;
    s [i] = 0 ;
    #pragma omp barrier
    // do computation into my portion of the work array
    w [i] = laburo (i) ;
    // Announce that I am doe my work:
    // The first  flush ensures that my work is visible before "s"
    // The second flush ensures that "s" is made visible
    #pragma omp flush (w)
    s [i] = 1 ;
    #pragma omp flush (s)
    // wait for the neighbor
    if (i > 0) 
      v = i - 1 ; 
    else { 
      v = omp_get_num_threads () - 1 ;
    } // end 
    while ( s [v] == 0 ) {
      #pragma omp flush (s)
    } // end while
    // read neighbor values from the work array
    // ... = w [v] ;
  } // end pragma
  // finaliza
  cout << endl ;
  cout << " finished "<< endl ;
  cout << endl ;
} // end main
// -----------------------------------------------------------------
