!  =================================================================
!   PGI:
!   pgf90 -V -Minfo -mp -fast -c omp_a13.f90
!   pgf90 -V -Minfo -mp -fast -o omp_a13_f90.exe omp_a13.o
!   omp_a13_f90.exe
! 
!  -----------------------------------------------------------------
!   INTEL: 
!   source /opt/intel_cc_80/bin/iccvars.sh
!   alias f95='/opt/intel_fc_80/bin/ifort'
!   /opt/intel_fc_80/bin/ifort -openmp -c omp_a13.f90
!   /opt/intel_fc_80/bin/ifort -openmp -o omp_a13_f90.exe omp_a13.o
!   omp_a13_f90.exe
! 
!  -----------------------------------------------------------------
!   ADAPTOR:
!   adaptor -openmp -free -o omp_a13_ada.exe omp_a13.f90
!   export OMP_NUM_THREADS=2 ; echo $OMP_NUM_THREADS
!   omp_a13_ada.exe
!
!  -----------------------------------------------------------------
program a13
  implicit none
  integer, parameter     :: n = 100
  integer, dimension (n) :: w, s
  integer :: i, v
  integer :: omp_get_thread_num
  integer :: omp_get_num_threads
  ! titulos
  write (*,*)
  write (*,*)'A13: using the flush directive without a list'
  write (*,*)
  !  tarea demo
  !omp$ parallel private (i,v) shared (w,s)
    i = omp_get_thread_num ()
    s (i) = 0
    !omp$ barrier
    ! do computation into my portion of the work array
    w (i) = laburo (i)
    ! Announce that I am doe my work:
    ! The first  flush ensures that my work is visible before "s"
    ! The second flush ensures that "s" is made visible
    !omp$ flush (w)
    s (i) = 1
    !omp$ flush (s)
    ! wait for the neighbor
    if (i > 0) then 
      v = i - 1
    else
      v = omp_get_num_threads () - 1
    end if 
    do while ( s (v) == 0 )
      !omp$ flush (s)
    end do
    ! read neighbor values from the work array
    ! ... = w [v] ;
  !omp$ end parallel
  ! finaliza
  write (*,*)
  write (*,*)'finished '
  write (*,*)
  contains
    integer function laburo (i) result (j)
      integer, intent (in) :: i
      j = i + 1
    end function
end program
!  =================================================================
