!  =================================================================
!   PGI:
!   pgf90 -V -Minfo -mp -fast -c omp_a14.f90
!   pgf90 -V -Minfo -mp -fast -o omp_a14_f90.exe omp_a14.o
!   omp_flush_f90.exe
! 
!  -----------------------------------------------------------------
!   INTEL: 
!   source /opt/intel_cc_80/bin/iccvars.sh
!   alias f95='/opt/intel_fc_80/bin/ifort'
!   /opt/intel_fc_80/bin/ifort -openmp -c omp_a14.f90
!   /opt/intel_fc_80/bin/ifort -openmp -o omp_a14_f90.exe omp_a14.o
!   omp_a14_f90.exe
! 
!  -----------------------------------------------------------------
!   ADAPTOR:
!   adaptor -openmp -free -o omp_a14_ada.exe omp_a14.f90
!   export OMP_NUM_THREADS=2 ; echo $OMP_NUM_THREADS
!   omp_a14_ada.exe
!
!  -----------------------------------------------------------------
program a14
  implicit none
  integer, target    :: x, h
  integer, pointer   :: p, j
  integer, parameter :: k = 7
  x = 0 ; p => x
  h = 0 ; j => h
  ! titulos
  write (*,*)
  write (*,*)'A14: using the flush directive without a list'
  write (*,*)
  write (*,*)' k     = ', k
  write (*,*)' G (k) = ', g (k)
  write (*,*)
  contains
    subroutine f1 (q)
      integer, pointer :: q
      q = 1
      !omp$ flush (q)
      ! x, p, *q are flushed since they are shared and accessible
      ! // while q is not flushed since it is not shared.
    end subroutine
    subroutine f2 (q)
      integer, pointer :: q
      !omp$ barrier
      q = 2
      !omp$ barrier
      ! a barrier implies a flus 
      ! x, p, *q  are flushed since they are shared and accessible
      ! while q is not flushed since it is not shared.
    end subroutine
    integer function g (n) result (suma)
      integer :: n
      integer :: i
      i    = 1
      suma = 0
      p    = 1
      !omp$ parallel reduction (+:suma) num_threads (2)
      call f1 (j)
      ! i, n, suma were not flushed since they were not accessible 
      ! in f1 while j was flushed since it was accessible
      suma = suma + j
      call f2 (j)
      ! i, n, suma were not flushed since they were not accessible 
      ! in f2 while j was flushed since it was accessible
      suma = suma + i + j + p + n
      !omp$ end parallel
    end function
end program
!  =================================================================
